;*****************************************************************************
; Suspend's intro 64kb for Rush Hours'98 c-party
; coded by mOtzEl / cRyOGeN^sUSPENd
;
; Last update: 22.04.98
;*****************************************************************************

.386p
include os.inc

code32 segment public para 'code' use32
assume  cs:code32,ds:code32,es:code32

include timer.inc     ; timer
include usmplay.inc   ; usm player
include uss.inc       ; useless sound system
include ussvar.inc    ; dev_name definition

include hardware.inc
include utils.inc     ; display macros (write, writeln)
                      ; there is no need for utils.asm with write and writeln.
USMOffset DD 0

;*****************************************************************************
; Wlaczenie wlasnych includow
;*****************************************************************************
include includes\fixed.inc
include includes\vesa_min.inc
include includes\div_hi.inc
include includes\fade_hi.inc
include includes\fx.inc
include includes\sincos.inc
include includes\others.inc
include includes\texture.inc
include includes\fx_loop.inc

;*****************************************************************************
; Pozycje poszczegolnych plikow w data.dat
;*****************************************************************************
font_address    equ 0
logo_address    equ 288*34 + 768
text1_address   equ logo_address + 128*64 + 768
text2_address   equ text1_address + 32*32 + 768
text3_address   equ text2_address + 32*32 + 768
text4_address   equ text3_address + 64*64 + 768
whooz_address   equ text4_address + 32*32 + 768
upland_address  equ whooz_address +  320*90 + 768

;*****************************************************************************
; Procedury programu
;*****************************************************************************

;*****************************************************************************
; Procka wywolywana przez timer
;*****************************************************************************
; Komendy synchronizacji: FF - flesz ekranu
;                         FE - wyswietlenie whooz normalnie
;                         FC - usuniecie whooz
;                         FB - zmiana na texture nr 1
;                         FA - zmiana na texture nr 2
;                         F9 - zmiana na texture nr 3
;                         F8 - zmiana na texture generowana
TimerProc Proc
        inc     TimerCount              ; zwieksz wartosc zmiennej TimerCount

        cmp     light, 0
        jle     nie_zmniejszaj
        dec     light                   ; zmniejsz wartosc light jesli <= 0
nie_zmniejszaj:

        cmp     _SynchroVal, 0ffh        ; jesli synchro = ffh to flesz
        jne     bez_flasha
        mov     light, 31
        mov     _SynchroVal, 0
        mov     text_status, 2
bez_flasha:

; ** sprawdzenie, czy wyswietlac 'whooz next' lub je usunac **
        cmp     _SynchroVal, 0feh
        jne     bez_loga_norm
        mov     whooz_status, 1
bez_loga_norm:
        cmp      _SynchroVal, 0fch
        jne      bez_wylaczania
        mov      whooz_status, 0
bez_wylaczania:

; ** zmiana tekstury na aktualnym efekcie **
        mov     eax, mem_allocated
        cmp     _SynchroVal, 0fbh
        jne     nie_text1
        add     eax, text1_ofs
        mov     texture_status, eax
nie_text1:
        cmp     _SynchroVal, 0fah
        jne     nie_text2
        add     eax, text2_ofs
        mov     texture_status, eax
nie_text2:
        cmp     _SynchroVal, 0f9h
        jne     nie_text3
        add     eax, text3_ofs
        mov     texture_status, eax
nie_text3:
        cmp     _SynchroVal, 0f8h
        jne     nie_textgen
        add     eax, text_gen_ofs
        mov     texture_status, eax
nie_textgen:

        ret
TimerProc EndP

;*****************************************************************************
; Procka inicjalizujaca
;*****************************************************************************
Init    Proc
        mov     eax, o TimerProc        ;\
        mov     ebx, TimerSpeed/(100)   ; wlaczenie timera ( 100 Hz )
        call    Timer_Start_            ;/

        mov     ah, Load_Internal_File  ; wczytanie danych - po kolei:
        mov     edx, O data_name        ; font, logo, texturki, whooz i modek
        Int_EOS
        mov     data_address, eax

        call    HardwareInit

        call    USS_AutoSetup
        jc      wyjscie

        write   '     Sound card: '

        mov     edx, _DEV_Name
        printf
        writeln

        mov     ah, Allocate_memory
        mov     edx, 1024*1024*4        ; narazie alokuje 4 mb
        Int_EOS
        jnc     mem_ok
        write   '     no enough memory !'
        jmp     wyjscie
mem_ok:
        mov     mem_allocated, edx
        xor     eax, eax
        mov     edi, mem_allocated
        mov     ecx, 1024*1024
        rep     stosd

        write   '     calculating'
        writeln

        mov     edx, 1
        mov     edi, mem_allocated      ; adres tablicy tunelu
        add     edi, Tunnel1_tbl_ofs
        call    Calculate_tunnel        ; wygenerowanie tablicy dla tunelu

        mov     edx, 0
        mov     edi, mem_allocated      ; adres tablicy tunelu
        add     edi, Tunnel2_tbl_ofs
        call    Calculate_tunnel        ; wygenerowanie tablicy dla tunelu

        mov     edi, mem_allocated
        add     edi, phongmap_ofs
        call    Calculate_phongmap      ; generowanie phongmapy

        call    Calc_eq_sin             ; wygenerowanie funkcji dla equalizera
        call    Calculate_sincos        ; wygenerowanie tablicy sin&cos

        mov     esi, data_address       ;\
        add     esi, text1_address      ;
        mov     edi, mem_allocated      ; rozszerzenie textury 32x32
        add     edi, Temp_ofs           ; do wielkosci 256x256
        call    Extend_texture          ;/

        mov     esi, mem_allocated      ;\
        add     esi, Temp_ofs           ;
        mov     ebp, data_address       ;  konwersja texturki 1 na hicolor
        add     ebp, text1_address + 32*32
        mov     edi, mem_allocated      ;
        add     edi, Text1_ofs          ;
        mov     edx, 256*256            ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, text2_address      ;
        mov     edi, mem_allocated      ; rozszerzenie textury 32x32
        add     edi, Temp_ofs           ; do wielkosci 256x256
        call    Extend_texture          ;/

        mov     esi, mem_allocated      ;\
        add     esi, Temp_ofs           ;
        mov     ebp, data_address       ;  konwersja texturki 2 na hicolor
        add     ebp, text2_address + 32*32
        mov     edi, mem_allocated      ;
        add     edi, Text2_ofs          ;
        mov     edx, 256*256            ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, text3_address      ;
        mov     edi, mem_allocated      ; rozszerzenie textury 64x64
        add     edi, Temp_ofs           ; do wielkosci 256x256
        call    Extend64                ;/

        mov     esi, mem_allocated      ;\
        add     esi, Temp_ofs           ;
        mov     ebp, data_address       ;  konwersja texturki 3 na hicolor
        add     ebp, text3_address + 64*64
        mov     edi, mem_allocated      ;
        add     edi, Text3_ofs          ;
        mov     edx, 256*256            ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, text4_address      ;
        mov     edi, mem_allocated      ; rozszerzenie textury 32x32
        add     edi, Temp_ofs           ; do wielkosci 256x256
        call    Extend_texture          ;/

        mov     esi, mem_allocated      ;\
        add     esi, Temp_ofs           ;
        mov     ebp, data_address       ;  konwersja texturki 4 na hicolor
        add     ebp, text4_address + 32*32
        mov     edi, mem_allocated      ;
        add     edi, Text4_ofs          ;
        mov     edx, 256*256            ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, logo_address       ;
        mov     ebp, esi                ;
        add     ebp, 128*64             ;
        mov     edi, mem_allocated      ;  konwersja logoska na hicolor
        add     edi, Logo_ofs           ;
        mov     edx, 128*64             ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, font_address       ;
        mov     ebp, esi                ;
        add     ebp, 288*34             ;
        mov     edi, mem_allocated      ;  konwersja fontu na hicolor
        add     edi, Font_ofs           ;
        mov     edx, 288*34             ;
        call    ConvertPic              ;/

        mov     esi, data_address       ;\
        add     esi, whooz_address      ;
        mov     ebp, esi                ;
        add     ebp, 320*90             ;
        mov     edi, mem_allocated      ;  konwersja whooz na hicolor
        add     edi, whooz_ofs          ;
        mov     edx, 320*90             ;
        call    ConvertPic              ;/

        mov     edi, mem_allocated      ;\
        add     edi, Temp_ofs           ; wygenerowanie texturki
        call    Make_texture            ;/

        mov     edi, o paleta           ; wygenerowanie palety texturki
        Rainbow 0, 0, 0, 63, 63, 63, 256

        mov     esi, mem_allocated      ;\
        add     esi, Temp_ofs
        mov     ebp, o paleta           ;
        mov     edi, mem_allocated      ;  konwersja texturki na hicolor
        add     edi, Text_gen_ofs       ;
        mov     edx, 256*256            ;
        call    ConvertPic              ;/

        mov     edi, o linia
        mov     ecx, 160
        xor     eax, eax
        rep     stosd

        mov     esi, data_address       ; kalkulacja shade2 table dla logoska
        add     esi, logo_address
        add     esi, 128*64
        mov     edi, mem_allocated
        add     edi, shade2_tbl_ofs
        call    calc_bump_shade_tbl

        mov     esi, data_address       ; kalkulacja shade table dla logoska
        add     esi, logo_address
        add     esi, 128*64
        mov     edi, mem_allocated
        add     edi, shade_tbl_ofs
        call    calc_shade_tbl

; ** shade table dla light RGB **
        mov     esi, data_address
        add     esi, text3_address
        add     esi, 64*64
        mov     edi, o paleta_pom
        mov     ecx, 33*3               ; tylko pierwsze 33 (0 - 32) kolory
        rep     movsb                   ; sa uzywane w texturze

        mov     esi, data_address
        add     esi, font_address
        add     esi, 288*34
        mov     ecx, 16*3               ; tylko pierwsze 16 (0 - 15) kolorow
        rep     movsb                   ; jest uzywane w foncie

        mov     esi, data_address
        add     esi, whooz_address
        add     esi, 320*90
        mov     ecx, 16*3               ; tylko pierwsze 16 (0 - 15) kolorow
        rep     movsb                   ; jest uzywane w logosku whooz_next

        mov     edi, mem_allocated
        add     edi, shade3_tbl_ofs
        mov     esi, o paleta_pom
        call    calc_shade_tbl

; ** paleta dla equalizera **
        mov     edi, o paleta           ; paleta teraz bedzie do equalizera
        xor     dx, dx
eq_pal_pet:
        mov     ax, dx                  ;\
        shr     ax, 2
        mov     bx, ax                  ; robimy przejscie od czarnego
        mov     cx, ax                  ; do bialego
        call    MakeCol16               ;/
        stosw

        inc     dx
        cmp     dx, 256
        jnz     eq_pal_pet

        mov     ecx, 4                  ; \
peti_zew:                               ;
        mov     edx, 2                  ;
peti_wew:                               ;
        mov     edi, mem_allocated      ; wygenerowanie bumpmapy pod
        add     edi, picture_buf_ofs    ; bumptunel
        mov     ebx, edx                ;
        dec     ebx                     ;
        shl     ebx, 7                  ;
        add     edi, ebx                ;
        mov     ebx, ecx                ;
        dec     ebx                     ;
        shl     ebx, 14                 ; 256*64 = 2^14
        add     edi, ebx                ;
                                        ;
        mov     esi, data_address       ;
        add     esi, logo_address       ;
                                        ;
        pusha                           ;
        call    Reversed_stamp          ;
        popa                            ;
                                        ;
        dec     edx                     ;
        jnz     peti_wew                ;
                                        ;
        dec     ecx                     ;
        jnz     peti_zew                ;
                                        ;
        mov     esi, mem_allocated      ;
        add     esi, picture_buf_ofs    ; generowanie bumpmapy
        call    calculate_bump          ;/

        call    VBE_Detect              ; jest vesa ?
        jc      byl_blad

        mov     ax, 320
        mov     bx, 200
        mov     dx, 16
        call    VBE_InitMode            ; wlacz tryb 320x200x16bit
        jc      byl_blad

        mov     esi, data_address
        add     esi, upland_address
        call    USMP_LoadInternalModule

        ret

byl_blad:
        write   '     Mode 320x200x16bit LFB not available !'

        mov     eax, TimerCount
        mov     ttest, eax
        call    USMP_StopPlay

        mov     eax, o TimerProc
        call    Timer_Stop_             ; wylaczenie timera

        mov     ax, 4c00h
        int     21h

wyjscie:
        mov     eax, TimerCount
        mov     ttest, eax
        call    USMP_StopPlay

        mov     eax, o TimerProc
        call    Timer_Stop_             ; wylaczenie timera

        clear_kbd

        mov     ax, 03
        int     10h

        write   '  S U S P E N D  P R O D U C T I O N  1 9 9 8   '
        writeln
        write   '-=  d a v e    m o t z e l    r a p p i d  =-'

        mov     ax, 4c00h
        int     21h

Init    EndP

;*****************************************************************************
;* Tu sie zaczyna wlasciwy program                                           *
;*****************************************************************************
Start32:
        call    Init

        call    USMP_StartPlay
        jc      wyjscie

        mov     edi, virtual_screen
        call    Clear_buffer

        mov     TimerCount, eax
        mov     prevTimerCount, eax

; *************************************************************************
;  fade in logoska
; *************************************************************************
        call    fx_fadein

; *************************************************************************
;  gel logoska
; *************************************************************************
        call    fx_setup_gel
        call    wyrownaj_timer
        call    fx_gel

; *************************************************************************
;  podwojny tunel
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_double_tun
        mov     eax, mem_allocated
        add     eax, text3_ofs
        mov     texture_status, eax
pet_3:
        mov     edx, mem_allocated
        add     edx, Tunnel1_tbl_ofs
        mov     esi, texture_status
        call    fx_double_tun

        cmp     _SynchroCount, 1dh
        jl      pet_3

; *************************************************************************
;  nalozone na siebie tunele bez perspektywy
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_tun_poj
pet8:
        call    wait_timer

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text2_ofs
        mov     edi, virtual_screen
        call    Do_poj_tunnel           ; wlasciwa procka

        mov     eax, 1280*200*2 + 2*320*2
        sub     eax, inc1
        mov     inc1, eax

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text2_ofs
        mov     edi, mem_allocated
        add     edi, Temp_ofs
        call    Do_poj_tunnel           ; wlasciwa procka

        call    Add_tunnels             ; nalozenie tuneli na siebie

        call    Equalizer

        mov     eax, TimerCount
        sub     eax, prevTimerCount
skip_frame8:
        call    Zmien_parametry3        ; zmiana pozycji swiatla
        add     increment, 4 + 512      ; ruch tunelu
        dec     eax
        jnz     skip_frame8

        mov     eax, 0
        call    esc_key

        call    wyrownaj_timer

        cmp     _SynchroCount, 029h
        jl      pet8

; *************************************************************************
;  pojedynczy tunel bez perspektywy
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_tun_poj
        mov     eax, mem_allocated
        add     eax, text_gen_ofs
        mov     texture_status, eax
pet9:
        call    wait_timer

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, texture_status
        call    fx_tun_poj

        cmp     _SynchroCount, 048h
        jl      pet9

; *************************************************************************
;  dwa tunele bez perspektywy
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_double_tun
        mov     esi, mem_allocated
        add     esi, text2_ofs
        mov     texture_status, esi
        mov     posy, 1280*2*100
        mov     posx, 4*130
        call    Zmien_parametry
pet_4:
        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, texture_status
        call    fx_double_tun

        cmp     _SynchroCount, 054h
        jl      pet_4

; *************************************************************************
;  pojedynczy tunel
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_tun_poj
pet6:
        call    wait_timer

        mov     edx, mem_allocated
        add     edx, Tunnel1_tbl_ofs
        mov     esi, texture_status
        call    fx_tun_poj

        cmp     _SynchroCount, 060h
        jl      pet6

; *************************************************************************
;  wobble tunnel bez perspektywy
; *************************************************************************
        call    fx_setup_wobble
        mov     incx_temp, -2
pet10:
        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs

        call    fx_wobble_tun

        cmp     _SynchroCount, 070h
        jl      pet10

; *************************************************************************
;  bump tunel
; *************************************************************************
        call    fx_setup_bumptun
        call    wyrownaj_timer
pet5:
        call    fx_bumptun

        cmp     _SynchroCount, 083h
        jl      pet5

; *************************************************************************
;  nalozone na siebie tunele bez perspektywy ( gwiazdki )
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_tun_poj
pet11:
        call    wait_timer

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text4_ofs
        mov     edi, virtual_screen
        call    Do_poj_tunnel           ; wlasciwa procka

        mov     eax, 1280*200*2 + 2*320*2
        sub     eax, inc1
        mov     inc1, eax

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text4_ofs
        mov     edi, mem_allocated
        add     edi, Temp_ofs
        call    Do_poj_tunnel           ; wlasciwa procka

        call    Add_tunnels             ; nalozenie tuneli na siebie

        call    Equalizer

        mov     eax, TimerCount
        sub     eax, prevTimerCount
skip_frame11:
        call    Zmien_parametry3        ; zmiana pozycji swiatla
        add     increment, 4 + 512      ; ruch tunelu
        dec     eax
        jnz     skip_frame11

        mov     eax, 0
        call    esc_key

        call    wyrownaj_timer

        cmp     _SynchroCount, 0b6h
        jl      pet11

; *************************************************************************
;  nalozone na siebie tunele
; *************************************************************************
        call    wyrownaj_timer
        call    fx_setup_tun_poj
pet7:
        call    wait_timer

        mov     edx, mem_allocated
        add     edx, Tunnel1_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text3_ofs
        mov     edi, virtual_screen
        call    Do_poj_tunnel           ; wlasciwa procka

        mov     eax, 1280*200*2 + 2*320*2
        sub     eax, inc1
        mov     inc1, eax

        mov     edx, mem_allocated
        add     edx, Tunnel1_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text3_ofs
        mov     edi, mem_allocated
        add     edi, Temp_ofs
        call    Do_poj_tunnel           ; wlasciwa procka

        call    Add_tunnels             ; nalozenie tuneli na siebie

        call    Equalizer

        mov     eax, TimerCount
        sub     eax, prevTimerCount
skip_frame7:
        call    Zmien_parametry3        ; zmiana pozycji swiatla
        add     increment, 4 + 512      ; ruch tunelu
        dec     eax
        jnz     skip_frame7

        mov     eax, 0
        call    esc_key

        call    wyrownaj_timer

        cmp     _SynchroCount, 0cfh
        jl      pet7

; *************************************************************************
;  woble z nalozonymi swiatelkami
; *************************************************************************
        call    wyrownaj_timer
        mov     esi, mem_allocated
        add     esi, text2_ofs
        mov     texture_status, esi
        mov     mult, 32
        call    calculate_sincos
        mov     incx_temp, -2

pet12:
        mov     eax, 200*320*4+160*4
        mov     inc1, eax

        call    wait_timer

        mov     esi, texture_status
        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     edi, virtual_screen
        call    Do_wobble_tun           ; wlasciwa procka

        mov     eax, 1280*200*2 + 2*320*2
        sub     eax, inc1
        mov     inc1, eax

        mov     edx, mem_allocated
        add     edx, Tunnel2_tbl_ofs
        mov     esi, mem_allocated
        add     esi, text4_ofs
        mov     edi, mem_allocated
        add     edi, Temp_ofs
        call    Do_poj_tunnel           ; wlasciwa procka

        call    Add_tunnels             ; nalozenie tuneli na siebie

        call    Equalizer

        mov     eax, TimerCount
        sub     eax, prevTimerCount
skip_frame12:
        mov     ebx, incx_temp
        add     increment, ebx          ; ruch tunelu
        call    Zmien_parametry3        ; zmiana pozycji swiatla
        dec     eax
        jnz     skip_frame12

        mov     eax, 0
        call    esc_key

        call    wyrownaj_timer

        cmp     _SynchroCount, 0dfh
        jnz     pet12

; *************************************************************************
;  light RGB
; *************************************************************************
sumthin:
        call    fx_setup_light
        call    wyrownaj_timer
l_petla:
        call    fx_light

        cmp     _SynchroCount, 0e4h
        jnz     l_petla

; *************************************************************************
;  koncowy bump
; *************************************************************************
        call    fx_setup_bump
        call    wyrownaj_timer
pet_bump:
        call    fx_bump

        cmp     _SynchroCount, 0e5h
        jl      pet_bump

        jmp     wyjscie

;*****************************************************************************
;* Tu sa dane programu                                                       *
;*****************************************************************************
align 4
data_address    dd 0
picture_address dd 0
TimerCount      dd 0
prevTimerCount  dd 0
mem_allocated   dd 0
ttest           dd 0
incx_temp       dd 0
incy_temp       dd 0
mult_temp       dd 256
light           dd 0
text_status     dd 0                    ; 0 - nie rysuj, 1 - rysuj, 2 - zmiana
texture_status  dd 0                    ; ktora tekstura jest uzywana
text_addy       dd o texty
shade_tbl       dd 0                    ; ktory shade table jest uzywany

sinus           dw 256 dup (?)          ; sinus * 25
sin_eq          dw 320 dup (?)

linia           dw 320 dup (?)
paleta          db 768 dup (?)
paleta_pom      db 768 dup (0)

data_name       db 'data.dat', 0

whooz_status    db 0

texty:
include includes\texty.inc

credits_txt     db 'dave motzel rappid', 0
our_txt         db 'our contribution', 0
to_txt          db 'to', 0
rh_txt          db 'rush hours 98 copy party', 0

code32 ends

end
