;*****************************************************************************
; Moveable tunel interference hicolor
; Zalozenia:
;   w ESI jest adres tekstury 256x256x256
;   w EDX jest adres tablicy tunelu
;   przyrost do offsetu w tablicy nazywa sie increment
;   pozycje tunelu okresla zmienna inc1 ( inc1 = x*2 + y*1280 )
;*****************************************************************************
align 4
incx            dd 4
incy            dd 1280*2
posx            dd 0
posy            dd 0
increment       dd 0
inc1            dd 0
inc2            dd 1280*200*2 + 2*320*2
Do_tunnel       Proc
        mov     edi, virtual_screen     ; bufor ekranu w edi
        add     edx, inc1
        mov     eax, edx                ; samomodyfikacja kodu
        add     eax, 1280*200*2         ; edx sluzy jako laczony: licznik
        mov     d [porow], eax          ; petli i adres tablicy tunelu
        mov     ebp, increment
        mov     eax, inc2
        sub     eax, inc1
        mov     inc2, eax
pettuny:
        xor     ecx, ecx
pettunx:
        mov     ebx, edx                ; ebx = y * 640 * 4
        add     ebx, inc2
        mov     eax, [edx + ecx]        ; eax = table[y*640*4 + x*4 + inc1]
        sub     eax, [ebx + ecx]

        add     eax, ebp                ; dodaj inkrement tunelu

        and     eax, 1ffffh             ; upewnij sie ze punkt jest w text.

        mov     ax, [esi + eax]         ; pobierz odpowiedni punkt z tekstury
        stosw

        add     ecx, 4
        cmp     ecx, 320*4              ; 320 przebiegow petli po x
        jnz     pettunx                 ; koniec petli x ?

        add     edx, 640*4
        cmp     edx, 640*200*4          ; 200 przebiegow petli po y
porow = $ - 4
        jnz     pettuny                 ; koniec petli y ?

        ret
Do_tunnel       EndP

;*****************************************************************************
; Calculate_tunnel ( procka wykorzystuje koprocha )
; Wejscie:
;   EDX - jesli 1 to normalny tunel, 0 - bez perspektywy
;   EDI - adres bufora na tablice tunelu
; Wyjscie:
;   brak
;*****************************************************************************
persp   dd 3500                         ; promien tunelu
degs    dd 128
temp    dd 0
temp2   dd 0
pi      dd 0
tx      dd 0
ty      dd 0
Calculate_tunnel        Proc
        mov     ecx, 400
        finit
        fldpi
        fstp    pi
petla_y:
        mov     ebp, 640

petla_x:
        mov     eax, 320
        sub     eax, ebp
        mov     temp, eax

        mov     eax, 200
        sub     eax, ecx
        mov     temp2, eax

        fild    temp2
        fild    temp
        fpatan
        mov     degs, 128
        fimul   degs
        fdiv    pi
        frndint
        fistp   ty

        fild    temp
        fimul   temp
        fild    temp2
        fimul   temp2
        faddp
        fsqrt

        cmp     edx, 1
        jnz     bez_persp

        fild    persp
        fdiv    st, st(1)
bez_persp:

        frndint
        fistp   tx
        ffree   st(0)
        xor     eax, eax
        mov     al, b ty
        shl     eax, 9
        xor     ebx, ebx
        mov     bl, b tx
        shl     ebx, 1
        add     eax, ebx
        stosd

        dec     ebp
        jnz     petla_x

        dec     ecx
        jnz     petla_y

        ret
Calculate_tunnel        EndP

Zmien_parametry Proc
        mov     ecx, incx
        mov     ebx, incy
        add     posx, ecx
        add     posy, ebx

        cmp     posx, 0
        jg      ok_x1
        mov     incx, 4
ok_x1:  cmp     posx, 320*4
        jl      ok_x2
        mov     incx, -4
ok_x2:
        cmp     posy, 0
        jg      ok_y1
        mov     incy, 1280*2
ok_y1:  cmp     posy, 200*1280*2
        jl      ok_y2
        mov     incy, -1280*2
ok_y2:

        mov     ecx, posy
        mov     ebx, posx
        add     ecx, ebx
        mov     inc1, ecx

        mov     ebx, 1280*200*2 + 2*320*2
        sub     ebx, ecx
        mov     inc2, ebx

        ret
Zmien_parametry EndP

;*****************************************************************************
; Gel hicolor - wersja z samomodyfikacja kodu
; Zalozenia :
;   w ESI jest adres obrazka
;   w zmiennych inc_x, inc_y jest przesuniecie
;*****************************************************************************
align 2
inc_x dw 0
inc_y dw 0
Do_gel  Proc
        mov     edi, [virtual_screen]           ; renderuj na ekran
        mov     ebp, 0                          ; y = 0
        mov     ax, inc_x                       ; samomodyfikacja kodu
        mov     w [g_inc1], ax                  ; wpisanie inc_x do pamieci
        mov     ax, inc_y                       ; samomodyfikacja kodu
        mov     w [g_inc2], ax                  ; wpisanie inc_y do pamieci
g_pety:
        mov     ecx, 320                        ; x = 320
g_petx:
        mov     eax, 320
        sub     ax, cx                          ; mov ax, x
        add     ax, bp                          ; add ax, y
        and     eax, 000000ffh
        sal     eax, 1                          ; tablica jest typu word
        mov     bx, sinus[eax]                  ; k = sin[ (x+y) & 255 ]

        mov     eax, 320
        sub     ax, cx                          ; mov ax, x
        mov     edx, eax
        add     ax, bx                          ; x + k
        add     ax, 1234h                       ; x + inc_x + k
        g_inc1 = $ - 2
        and     eax, 000000ffh
        sal     eax, 1                          ; tablica jest typu word
        add     dx, sinus[eax]                  ; x + sin[ (x+inc_x+k) & 255 ]

        mov     ax, bp                          ; ax = y
        sub     bx, 1234h                       ; bx = k - inc_y
        g_inc2 = $ - 2
        sub     bx, ax                          ; bx = k - incy - y
        neg     bx                              ; bx = -k + inc_y + y
        and     ebx, 000000ffh
        sal     ebx, 1                          ; tablica jest typu word
        sub     ax, sinus[ebx]                  ; y - sin[ (y+inc_y-k) & 255 ]

        cmp     dx, 319                         ;\
        jg      bad                             ;
        cmp     ax, 199                         ;  sprawdz, czy wspolrzedne
        jg      bad                             ;  x mieszcza sie w (0, 320)
        cmp     dx, 0                           ;  a y mieszcza sie w (0, 200)
        jl      bad                             ;
        cmp     ax, 0                           ;
        jl      bad                             ;/

        sal     edx, 1
        sal     eax, 9                          ;\
        add     edx, eax                        ; edx = x + y * 320*2
        sar     eax, 2                          ;
        add     edx, eax                        ;/
        mov     ax, [esi + edx]                 ; pobierz bajt z bitmapy
        stosw                                   ; postaw go na ekranie
        jmp     good
bad:
        xor     ax, ax                          ; postaw czarny
        stosw                                   ; punkt na ekranie
good:
        dec     ecx
        jnz     g_petx                          ; jeszcze petla x ?

        inc     ebp
        cmp     ebp, 200
        jnz     g_pety                          ; jeszcze petla y ?

        ret
Do_gel  EndP

;*****************************************************************************
; Equalizer
;*****************************************************************************
Equalizer       Proc
        mov     edi, mem_allocated
        add     edi, 55*320 + 1 + Equalizer_ofs
        mov     esi, o sin_eq

        mov     ecx, 6
ds_petzew:
        call    Random
        and     ebx, 0fh
        mov     ebp, ebx

        mov     edx, 53
ds_petwew:
        xor     eax, eax
        xor     ebx, ebx
        mov     bl, [VchVolume]
        sub     eax, ebx
        mov     bl, [VchVolume+1]
        sub     eax, ebx
        shr     eax, 2
        mov     ebx, eax

        lodsw
        cwde

        add     ebx, ebp                ; dodaj random

        add     ebx, eax
        mov     eax, ebx
        sal     ebx, 8
        sal     eax, 6
        add     ebx, eax
        mov     b [edi + ebx + 320], 192
        mov     b [edi + ebx], 255
        mov     b [edi + ebx - 320], 192

        inc     edi
        dec     edx
        jnz     ds_petwew

        dec     ecx
        jnz     ds_petzew

; **** Rozmycie bufora ****

        mov     edi, mem_allocated
        add     edi, 321 + Equalizer_ofs

        mov     ebp, 98*320
blrpet:
        xor     edx, edx
        mov     dl, [edi - 1]
        mov     eax, edx
        mov     dl, [edi + 1]
        add     eax, edx
        mov     dl, [edi + 320]
        add     eax, edx
        mov     dl, [edi - 320]
        add     eax, edx
        shr     eax, 2

        sub     eax, 3
        cmp     eax, 24
        jnl     wieksze_od_zera
        xor     eax, eax
wieksze_od_zera:
        stosb

        dec     ebp
        jnz     blrpet

; **** Wyswietlenie na ekranie ****

        mov     esi, mem_allocated
        add     esi, Equalizer_ofs
        mov     edi, virtual_screen
        add     edi, 320*100*2
        mov     ecx, 320*100
        mov     ebp, o paleta
ss_pet:
        xor     eax, eax
        lodsb
        cmp     al, 0
        je      ss_dal

        sal     eax, 1
        mov     dx, [eax + ebp]

        mov     [edi], dx
ss_dal:
        add     edi, 2

        dec     ecx
        jnz     ss_pet

        ret
Equalizer       EndP

;*****************************************************************************
; Bumpmapper hicolor
; Zalozenia :
;   w ESI jest adres bumpmapy
;   adres obrazka zawiera zmienna picture_address
;   w zmiennych lx i ly znajduje sie polozenie zrodla swiatla
;*****************************************************************************
lx      dw 0
ly      dw 0
Do_bump Proc
        mov     edi, virtual_screen
        add     lx, 128                         ; poprawienie zrodla swiatla
        add     ly, 128                         ; do srodka phongmapy
        mov     ecx, 321
        xor     eax, eax
        rep     stosw                           ; wyczysc gorna linie ekranu
        add     esi, 321                        ; bez first i last linii
        mov     ecx, 1                          ; 198 linii od 1
bpetla_y:
        mov     ebp, 1                          ; 318 punktow w lini od 1
        sub     cx, ly                          ; cx = (y - ly)
bpetla_x:
        mov     eax, mem_allocated              ; adres phongmapy
        add     eax, phongmap_ofs
        movzx   bx, b [esi+1]
        movzx   dx, b [esi-1]
        sub     bx, dx                          ; nx = *(temp+1) - *(temp-1)

        sub     bx, bp
        add     bx, lx                          ; nx -= ( x - lx )

        mov     dx, bx                          ; sprawdz, czy nx miesci sie
        and     dx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew                          ; nie to skocz to et. na_zew

        and     ebx, 0000ffffh                  ;
        add     eax, ebx                        ; dodaj do adresu phongmapy

        movzx   bx, b [esi+320]
        movzx   dx, b [esi-320]
        sub     bx, dx                          ; ny = *(temp+1) - *(temp-1)
        sub     bx, cx                          ; ny -= ( y - ly )

        mov     dx, bx                          ; sprawdz, czy ny miesci sie
        and     dx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew                          ; nie to skocz to et. na_zew

        and     ebx, 0000ffffh
        sal     bx, 8                           ; ny <<= 8
        add     eax, ebx                        ; oblicz adres w phongmapie
        mov     al, [eax]                       ; pobierz poziom jasnosci
        shr     al, 2                           ; przeksztalc w zakres 0-63
        and     eax, 03fh

        mov     edx, picture_address
        mov     ebx, ecx
        add     bx, ly                          ; od cx bylo odejmowane ly
        sal     ebx, 8
        add     edx, ebx
        shr     ebx, 2
        add     edx, ebx
        add     edx, ebp
        xor     ebx, ebx
        mov     bl, [ edx ]
        sal     ebx, 7
        add     ebx, eax
        add     ebx, eax
        mov     edx, shade_tbl
        mov     ax, [edx + ebx]

        stosw                                   ; postaw pixel
        jmp     b_dal

na_zew:
        xor     ax, ax                          ; postaw czarny pixel, u lub v
        stosw                                   ; nie bylo w zakresie 0 - 255

b_dal:
        inc     esi                             ; nastepny punkt bumpmapy

        inc     ebp
        cmp     ebp, 319                        ; tylko 318 punktow ( od 1 )
        jl      bpetla_x                        ; czy juz koniec petli x ?

        add     esi, 2                          ; bez pierwszego i
;        add     edi, 4                          ; ostatniego punktu w linii
        xor     eax, eax
        stosd

        add     cx, ly                          ; od cx bylo odejmowane ly

        inc     ecx
        cmp     ecx, 199                        ; tylko 198 linii ( od 1 )
        jl      bpetla_y                        ; czy juz koniec petli y ?

        mov     ecx, 319
        xor     eax, eax
        rep     stosw

        ret
Do_bump EndP

;*****************************************************************************
; Bumpmapper hicolor 256x256 - procka juz troche zoptymalizowana
; Zalozenia :
;   w ESI jest adres bumpmapy
;   w EDI jest adres bufora, do ktorego renderowac
;   adres obrazka zawiera zmienna picture_address
;   w zmiennych lx i ly znajduje sie polozenie zrodla swiatla
;*****************************************************************************
Do_bump256      Proc
        push    edi
        add     lx, 128                         ; poprawienie zrodla swiatla
        add     ly, 128                         ; do srodka phongmapy
        xor     ecx, ecx
b2petla_y:
        xor     ebp, ebp
        sub     cx, ly                          ; cx = (y - ly)
b2petla_x:
        mov     eax, mem_allocated              ; adres phongmapy
        add     eax, phongmap_ofs
        movzx   bx, b [esi+1]
        movzx   dx, b [esi-1]
        sub     bx, dx                          ; nx = *(temp+1) - *(temp-1)

        sub     bx, bp
        add     bx, lx                          ; nx -= ( x - lx )

        and     ebx, 0ffh                       ;
        add     eax, ebx                        ; dodaj do adresu phongmapy

        movzx   bx, b [esi+256]
        movzx   dx, b [esi-256]
        sub     bx, dx                          ; ny = *(temp+1) - *(temp-1)
        sub     bx, cx                          ; ny -= ( y - ly )

        and     ebx, 0ffh

        sal     ebx, 8                          ; ny <<= 8
        add     eax, ebx                        ; oblicz adres w phongmapie
        mov     al, [eax]                       ; pobierz poziom jasnosci
        shr     al, 2                           ; przeksztalc w zakres 0-63

        add     al, 2                           ;\
        cmp     al, 63                          ;
        jle     ok_al                           ; podbicie jasnosci tunelu
        mov     eax, 63                         ;
ok_al:                                          ;/
        and     eax, 03fh

        mov     edx, picture_address
        mov     ebx, ecx
        add     bx, ly                          ; od cx bylo odejmowane ly
        sal     ebx, 8
        add     edx, ebx
        add     edx, ebp
        xor     ebx, ebx
        mov     bl, [ edx ]
        sal     ebx, 7
        add     ebx, eax
        add     ebx, eax
        mov     edx, shade_tbl
        mov     ax, [ebx + edx]

        stosw                                   ; postaw pixel

        inc     esi                             ; nastepny punkt bumpmapy

        inc     ebp
        cmp     ebp, 256
        jl      b2petla_x                       ; czy juz koniec petli x ?

        add     cx, ly                          ; od cx bylo odejmowane ly

        inc     ecx
        cmp     ecx, 256
        jl      b2petla_y                       ; czy juz koniec petli y ?

        pop     edi                             ;\
        mov     esi, edi                        ;
        add     esi, 256*2                      ;
        mov     ecx, 256/2                      ;  poprawienie pierwszej i
        rep     movsd                           ;  ostatniej linii bufora
                                                ;  ( zawieraja smieci )
        add     esi, 64512*2                    ;
        add     edi, 65024*2                    ;
        mov     ecx, 256/2                      ;
        rep     movsd                           ;/

        ret
Do_bump256      EndP

;*****************************************************************************
; Generuje bumpmape
;*****************************************************************************
calculate_bump  Proc
        push    esi
        mov     edi, mem_allocated
        add     edi, bumpmap_ofs
        mov     ecx, 256*256
cbpet1:
        call    Random
        add     al, bl
        stosb

        loop    cbpet1

        mov     ecx, 5
cbpet2:
        mov     edi, mem_allocated
        add     edi, bumpmap_ofs
        call    blur_bumpmap
        loop    cbpet2

        mov     esi, mem_allocated
        add     esi, bumpmap_ofs
        mov     edi, esi
        add     esi, 256
        mov     ecx, 256/4
        rep     movsd

        pop     esi
        mov     edi, mem_allocated
        add     edi, bumpmap_ofs
        mov     ecx, 256*256
cbpet3:
        xor     eax, ebx
        xor     ebx, ebx
        lodsb
        mov     bl, [edi]
        add     eax, ebx
        cmp     eax, 255
        jng     ok_bump
        mov     al, 255
ok_bump:
        stosb
        dec     ecx
        jnz     cbpet3

        ret
calculate_bump  EndP

;*****************************************************************************
; Rozmywa bumpmape 256x256
;*****************************************************************************
Blur_bumpmap    Proc
        push    ecx
        xor     ebp, ebp
bblrpet_y:
        xor     esi, esi
bblrpet_x:
        xor     edx, edx

        mov     ax, bp
        mov     dh, al
        mov     ax, si
        mov     dl, al
        mov     ecx, edx

        xor     eax, eax

        sub     edx, 1
        and     edx, 0ffffh
        mov     al, [edi + edx]
        mov     ebx, eax

        mov     edx, ecx
        sub     edx, -1
        and     edx, 0ffffh
        mov     al, [edi + edx]
        adc     ebx, eax

        mov     edx, ecx
        sub     edx, 256
        and     edx, 0ffffh
        mov     al, [edi + edx]
        adc     ebx, eax

        mov     edx, ecx
        add     edx, 256
        and     edx, 0ffffh
        mov     al, [edi + edx]
        adc     ebx, eax

        shr     ebx, 2
        mov     eax, ebx

        mov     edx, ecx
        and     edx, 0ffffh
        mov     [edi+edx], al

        inc     esi
        cmp     esi, 256
        jne     bblrpet_x

        inc     ebp
        cmp     ebp, 256
        jne     bblrpet_y

        pop     ecx
        ret
Blur_bumpmap    EndP

;*****************************************************************************
; Calculate phongmap
; Zalozenia :
;   w EDI jest adres bufora phongmapy
;*****************************************************************************
PHONG_PAR1 EQU 191
PHONG_PAR2 EQU 128

nx      dq 0
ny      dq 0
nz      dq 0
temp3   dq 0
Calculate_phongmap      Proc
        finit
        mov     ebp, 256                ; zmienna y
petl_y:
        mov     ecx, 256                ; zmienna x
petl_x:
        mov     temp, 128
        sub     temp, ecx               ; x - 128
        fild    temp
        mov     temp, 128
        fidiv   temp
        fst     nx                      ; (x - 128) / 128
        fmul    nx
        fstp    nx                      ; nx = nx * nx

        mov     temp, 128
        sub     temp, ebp               ; y - 128
        fild    temp
        mov     temp, 128
        fidiv   temp
        fst     ny                      ; (y - 128) / 128
        fmul    ny
        fst     ny                      ; ny = ny * ny
        fadd    nx                      ; st(0) = (nx * nx) + (ny * ny)
        fsqrt                           ; st(0) = sqrt( st(0) )
        fstp    nz
        fld1
        fsub    nz                      ; st(0) = 1 - sqrt( st(0) )
        fst     temp3                   ; zapamietanie
        mov     temp, 65536             ;\
        fimul   temp                    ; pomnozenie nz przez 65536
        frndint                         ; i zaokraglenie do liczby calkowitej
        fistp   temp                    ; potrzebne do porownania, czy nz<0
        fld     temp3                   ; bo nie dziala ftst
        cmp     temp, 0                 ; temp3 zapamietuje poprzednia wartosc
        jnl     ok_nz                   ;/
        fldz                            ; jesli nz < 0 to nz = 0
        ffree   st(1)                   ; rejestr st(1) jest juz niepotrzebny
ok_nz:
        fst     nz                      ; nz = 1 - sqrt( nx * nx + ny * ny)

        mov     temp, PHONG_PAR1
        fimul   temp                    ; st(0) = nz * 191
        fld     nz
        fmul    nz
        mov     temp, PHONG_PAR2
        fimul   temp                    ; st(0) = nz * nz * 128
        fadd                            ; st(0) = nz * nz * 128 + nz * 191
        frndint
        fistp   temp
        mov     eax, temp

        cmp     eax, 255                ; jesli kolor > 255 to kolor = 255
        jle     ok_col                  ;
        mov     al, 255                 ;
ok_col:
        stosb                           ; wpisz punkt do phongmapy
        dec     ecx
        jnz     petl_x

        dec     ebp
        jnz     petl_y
        ret
Calculate_phongmap      EndP

;*****************************************************************************
; Zmiana pozycji swiatla na podstawie wzorow :
;  lx = cos(t/15)*96+160
;  ly = sin(t/25)*66+100
;*****************************************************************************
zmien_parametry2        Proc
        finit
        fld     temp
        fadd    tx
        fst     temp
        mov     temp2, 15
        fidiv   temp2
        fcos
        mov     temp2, 96
        fimul   temp2
        frndint
        fistp   word ptr lx
        add     lx, 160

        fld     temp
        mov     temp2, 25
        fidiv   temp2
        fsin
        mov     temp2, 66
        fimul   temp2
        frndint
        fistp   word ptr ly
        add     ly, 100

        ret
zmien_parametry2        EndP

;*****************************************************************************
; Moveable tunel interference hicolor
; Zalozenia:
;   w ESI jest adres tekstury 256x256x256
;   w EDI jest bufor, do ktorego renderowac
;   w EDX jest adres tablicy tunelu
;   przyrost do offsetu w tablicy nazywa sie increment
;   pozycje tunelu okresla zmienna inc1 ( inc1 = x*2 + y*1280 )
;*****************************************************************************
Do_poj_tunnel   Proc
        add     edx, inc1
        mov     eax, edx                ; samomodyfikacja kodu
        add     eax, 1280*200*2         ; edx sluzy jako laczony: licznik
        mov     d [pojporow], eax       ; petli i adres tablicy tunelu
        mov     ebp, increment
pojtuny:
        xor     ecx, ecx
pojtunx:
        mov     eax, [edx + ecx]        ; eax = table[y*640*4 + x*4 + inc1]

;        mov     ebx, eax
;        add     ebx, ebp                ; dodaj inkrement tunelu
;        and     ebx, 0ffh
;        mov     ebx, [o sinus + ebx]
;        sal     ebx, 1
;        add     eax, ebx

        add     eax, ebp                ; dodaj inkrement tunelu

        and     eax, 1ffffh             ; upewnij sie ze punkt jest w text.
        mov     ax, [esi + eax]         ; pobierz odpowiedni punkt z tekstury
        stosw

        add     ecx, 4
        cmp     ecx, 320*4              ; 320 przebiegow petli po x
        jnz     pojtunx                 ; koniec petli x ?

        add     edx, 640*4
        cmp     edx, 640*200*4          ; 200 przebiegow petli po y
pojporow = $ - 4
        jnz     pojtuny                 ; koniec petli y ?

        ret
Do_poj_tunnel   EndP

;*****************************************************************************
; Tunel hicolor z zaburzeniami
; Zalozenia:
;   w ESI jest adres tekstury 256x256x256
;   w EDI jest bufor, do ktorego renderowac
;   w EDX jest adres tablicy tunelu
;   przyrost do offsetu w tablicy nazywa sie increment
;   pozycje tunelu okresla zmienna inc1 ( inc1 = x*2 + y*1280 )
;*****************************************************************************
Do_wobble_tun   Proc
        add     edx, inc1
        mov     eax, edx                ; samomodyfikacja kodu
        add     eax, 1280*200*2         ; edx sluzy jako laczony: licznik
        mov     d [porown], eax         ; petli i adres tablicy tunelu
        mov     ebp, increment
wpettuny:
        xor     ecx, ecx
wpettunx:
        mov     eax, [edx + ecx]        ; eax = table[y*640*4 + x*4 + inc1]

        mov     ebx, eax
        add     ebx, ebp                ; dodaj inkrement tunelu
        and     ebx, 0ffh
        mov     ebx, [o sinus + ebx]
        sal     ebx, 1
        add     eax, ebx

        and     eax, 1ffffh             ; upewnij sie ze punkt jest w text.
        mov     ax, [esi + eax]         ; pobierz odpowiedni punkt z tekstury
        stosw

        add     ecx, 4
        cmp     ecx, 320*4              ; 320 przebiegow petli po x
        jnz     wpettunx                ; koniec petli x ?

        add     edx, 640*4
        cmp     edx, 640*200*4          ; 200 przebiegow petli po y
porown = $ - 4
        jnz     wpettuny                ; koniec petli y ?

        ret
Do_wobble_tun   EndP

zmien_parametry3 Proc
        finit
        fld     temp
        fadd    tx
        fst     temp
        mov     temp2, 15
        fidiv   temp2
        fcos
        mov     temp2, 96
        fimul   temp2
        frndint
        fistp   posx
        shl     posx, 2
        add     posx, 160*4

        fld     temp
        mov     temp2, 25
        fidiv   temp2
        fsin
        mov     temp2, 66
        fimul   temp2
        frndint
        fistp   posy

        mov     ebx, posy
        shl     ebx, 11
        shl     posy, 9
        add     ebx, posy
        add     ebx, posx
        add     ebx, 200 * 320*4

        mov     inc1, ebx

        ret
zmien_parametry3 EndP

Add_tunnels     Proc
        mov     edi, virtual_screen
        mov     esi, edi
        mov     ebp, mem_allocated
        add     ebp, Temp_ofs
        mov     ecx, 64000
at_pet:
        mov     ax, [esi]
        mov     bx, [ebp]

        and     ax, 1111011111011110b
        shr     ax, 1
        and     bx, 1111011111011110b
        shr     bx, 1
        add     ax, bx

        stosw

        add     esi, 2
        add     ebp,2
        dec     ecx
        jnz     at_pet

        ret
Add_tunnels     EndP

whooz_normal    Proc
        mov     edi, virtual_screen
        add     edi, 320*55*2
        mov     esi, mem_allocated
        add     esi, Whooz_ofs

        mov     edx, 90
whn_zew:
        mov     ecx, 320
whn_wew:
        lodsw
        cmp     ax, 0
        jz      bez_pixela2

        mov     [edi], ax
bez_pixela2:
        add     edi, 2
        dec     ecx
        jnz     whn_wew

        dec     edx
        jnz     whn_zew

        ret
whooz_normal    EndP

;*****************************************************************************
; Light RGB hicolor
; Zalozenia :
;   w ESI jest adres obrazka
;   w zmiennych lx_r(g,b) i ly_r(g,b) znajduja sie polozenia zrodla swiatla
;*****************************************************************************
lx_r    dw 0
ly_r    dw 0
lx_g    dw 0
ly_g    dw 0
lx_b    dw 0
ly_b    dw 0
Do_light        Proc
        mov     edi, virtual_screen
        sub     lx_r, 128                       ; poprawienie zrodla swiatla
        sub     ly_r, 128                       ; do srodka phongmapy
        sub     lx_g, 128                       ; poprawienie zrodla swiatla
        sub     ly_g, 128                       ; do srodka phongmapy
        sub     lx_b, 128                       ; poprawienie zrodla swiatla
        sub     ly_b, 128                       ; do srodka phongmapy
        xor     ecx, ecx
dlpetla_y:
        xor     ebp, ebp
dlpetla_x:
        mov     eax, mem_allocated              ; adres phongmapy
        add     eax, phongmap_ofs

        mov     dx, bp
        sub     dx, lx_r                        ; mov dx, x - lx + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_r                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie x
        add     eax, edx                        ; do adresu phongmapy

        mov     dx, cx
        sub     dx, ly_r                        ; mov dx, y - ly + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_r                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie y
        sal     edx, 8                          ; do adresu
        add     eax, edx                        ; phongmapy

        mov     al, [eax]                       ; pobierz poziom jasnosci
        shr     al, 2                           ; przeksztalc w zakres 0-63
        and     eax, 03fh

        xor     ebx, ebx
        mov     bl, [ esi ]
        sal     ebx, 7
        add     ebx, eax
        add     ebx, eax
        mov     edx, shade_tbl
        mov     ax, [ebx + edx]

        and     ax, 0f800h                      ; tylko skladowa R
        push    ax
        jmp     next_skl_g

na_zew_r:
        xor     ax, ax
        push    ax

next_skl_g:
        mov     eax, mem_allocated              ; adres phongmapy
        add     eax, phongmap_ofs

        mov     dx, bp
        sub     dx, lx_g                        ; mov dx, x - lx + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_g                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie x
        add     eax, edx                        ; do adresu phongmapy

        mov     dx, cx
        sub     dx, ly_g                        ; mov dx, y - ly + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_g                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie y
        sal     edx, 8                          ; do adresu
        add     eax, edx                        ; phongmapy

        mov     al, [eax]                       ; pobierz poziom jasnosci
        shr     al, 2                           ; przeksztalc w zakres 0-63
        and     eax, 03fh

        xor     ebx, ebx
        mov     bl, [ esi ]
        sal     ebx, 7
        add     ebx, eax
        add     ebx, eax
        mov     edx, shade_tbl
        mov     ax, [ebx + edx]

        and     ax, 07e0h                       ; tylko skladowa G
        pop     bx
        or      ax, bx
        push    ax
        jmp     next_skl_b

na_zew_g:
        pop     bx
        xor     ax, ax
        or      ax, bx
        push    ax

next_skl_b:
        mov     eax, mem_allocated              ; adres phongmapy
        add     eax, phongmap_ofs

        mov     dx, bp
        sub     dx, lx_b                        ; mov dx, x - lx + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_b                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie x
        add     eax, edx                        ; do adresu phongmapy

        mov     dx, cx
        sub     dx, ly_b                        ; mov dx, y - ly + 128

        mov     bx, dx                          ; sprawdz, czy nx miesci sie
        and     bx, 0ff00h                      ; w zakresie 0 - 255, jesli
        jnz     na_zew_b                        ; nie to skocz to et. na_zew

        and     edx, 0ffh                       ; dodaj przesuniecie y
        sal     edx, 8                          ; do adresu
        add     eax, edx                        ; phongmapy

        mov     al, [eax]                       ; pobierz poziom jasnosci
        shr     al, 2                           ; przeksztalc w zakres 0-63
        and     eax, 03fh

        xor     ebx, ebx
        mov     bl, [ esi ]
        sal     ebx, 7
        add     ebx, eax
        add     ebx, eax
        mov     edx, shade_tbl
        mov     ax, [ebx + edx]

        and     ax, 01fh                        ; tylko skladowa B
        pop     bx
        or      ax, bx
        jmp     next_skl_sth

na_zew_b:
        xor     ax, ax
        pop     bx
        or      ax, bx

next_skl_sth:

        stosw                                   ; postaw pixel
        inc     esi                             ; nastepny punkt obrazka

        inc     ebp
        cmp     ebp, 320
        jl      dlpetla_x                       ; czy juz koniec petli x ?

        inc     ecx
        cmp     ecx, 200
        jl      dlpetla_y                       ; czy juz koniec petli y ?

        ret
Do_light        EndP


;*****************************************************************************
; Zmiana pozycji swiatla na podstawie wzorow
;  lx = cos(t/15)*96+160
;  ly = sin(t/25)*66+100
;*****************************************************************************
zmien_parametry4 Proc
        finit
        fld     temp
        fadd    tx
        fst     temp
        mov     temp2, 15
        fidiv   temp2
        fcos
        mov     temp2, 96
        fimul   temp2
        frndint
        fistp   word ptr lx_g
        add     lx_g, 160

        fld     temp
        mov     temp2, 25
        fidiv   temp2
        fsin
        mov     temp2, 66
        fimul   temp2
        frndint
        fistp   word ptr ly_g
        add     ly_g, 100

        mov     cx, 320
        sub     cx, lx_g
        mov     lx_r, cx

        mov     cx, 200
        sub     cx, ly_g
        mov     ly_r, cx

        mov     cx, 260
        sub     cx, lx_g
        mov     lx_b, cx

        mov     cx, 140
        sub     cx, ly_g
        mov     ly_b, cx

        ret
zmien_parametry4 EndP

; wypelnia 320x200 (w edi) ekran, textura 64x64 (w esi)
Fill_by_text    Proc
        xor     ax, ax
        mov     ebp, 256
fbt_pety:
        mov     edx, 256
fbt_petx:
        xor     ebx, ebx
        mov     bl, ah
        sal     ebx, 6
        add     bl, al
        mov     bl, [esi + ebx]
        mov     b [edi], bl
        inc     edi

        inc     al
        and     al, 3fh

        dec     edx
        jnz     fbt_petx

        inc     ah
        and     ah, 3fh
        xor     al, al

        dec     ebp
        jnz     fbt_pety

        ret
Fill_by_text    EndP

Stamp_whooz     Proc
        mov     edx, 90
swn_zew:
        mov     ecx, 320
swn_wew:
        lodsb
        cmp     al, 0
        jz      nie_stawiaj

        add     al, 49
        mov     [edi], al

nie_stawiaj:
        inc     edi

        dec     ecx
        jnz     swn_wew

        dec     edx
        jnz     swn_zew

        ret
Stamp_whooz     EndP

; w edi adres bufora, w ebp adres tekstu
Stamp_text      Proc
st_pet_zew:
        mov     esi, data_address
        add     esi, font_address
        xor     eax, eax
        mov     al, [ebp]
        cmp     al, 0
        jz      st_koniec

        cmp     al, 97
        jnl     nie_literka2
        add     esi, 288*17
        sub     eax, 32
        jmp     here2
nie_literka2:
        sub     eax, 97
here2:
        mov     ebx, eax                ;\
        add     ebx, eax                ; obliczenie ofsetu znaku, czyli
        add     ebx, eax                ; (eax - 97) * 11
        shl     eax, 3                  ;
        add     ebx, eax                ;/

        mov     eax, 16
st_pet_wew_y:
        mov     ecx, 10
st_pet_wew_x:
        mov     dl, [esi + ebx]

        cmp     dl, 0
        jz      st_nie_rysuj
        add     dl, 33
        mov     [edi], dl
st_nie_rysuj:

        inc     edi
        inc     ebx
        dec     ecx
        jnz     st_pet_wew_x

        add     edi, 320 - 10
        add     ebx, 288 - 10

        dec     eax
        jnz     st_pet_wew_y

        inc     ebp
        sub     edi, 320*16-10
        jmp     st_pet_zew

st_koniec:
        ret
Stamp_text      EndP

