;*****************************************************************************
; Makro wyswietlajace tekst na ekranie
; Zalozenia :
;   w EDI jest podany offset do tekstu zakonczonego znakiem '$'
;*****************************************************************************
printf  Macro

        mov     ah,9
        int     21h
EndM

;*****************************************************************************
;Macro czekajace na powrot pionowy
;*****************************************************************************
waitVBL Macro
local   vrt,novrt
        mov   dx,3dah
vrt:    in    al,dx             ;\
        test  al,8              ; czekaj, az skonczy sie powrot pionowy
        jnz   vrt               ;/
novrt:  in    al,dx             ;\
        test  al,8              ; czekaj na powrot pionowy
        jz    novrt             ;/
EndM

;*****************************************************************************
; Makro czyszczace bufor klawiatury
;*****************************************************************************
clear_kbd       Macro

        push    es
        mov     ax, 40h
        mov     es, ax
        mov     al, es:[01ah]
        mov     es:[01ch], al
        pop     es
EndM

;*****************************************************************************
; Procka rozszerza texturke 32x32 do wielkosci 256x256
; Wejscie:
;   ESI - textura 32x32
;   EDI - bufor na teksture 256x256
; Wyjscie:
;   brak
;*****************************************************************************
Extend_texture  Proc
        mov     ecx, 256
ex_pet_zew:
        mov     edx, 256
ex_pet_wew:
        mov     eax, edx
        mov     ebx, ecx
        and     eax, 31
        and     ebx, 31
        shl     ebx, 5
        add     eax, ebx
        mov     al, [esi + eax]
        stosb
        dec     edx
        jnz     ex_pet_wew

        dec     ecx
        jnz     ex_pet_zew

        ret
Extend_texture  EndP

;*****************************************************************************
; Procka rozszerza texturke 64x64 do wielkosci 256x256
; Wejscie:
;   ESI - textura 64x64
;   EDI - bufor na teksture 256x256
; Wyjscie:
;   brak
;*****************************************************************************
Extend64        Proc
        mov     ecx, 256
ex64_zew:
        mov     edx, 256
ex64_wew:
        mov     eax, edx
        mov     ebx, ecx
        and     eax, 63
        and     ebx, 63
        shl     ebx, 6
        add     eax, ebx
        mov     al, [esi + eax]
        stosb
        dec     edx
        jnz     ex64_wew

        dec     ecx
        jnz     ex64_zew

        ret
Extend64        EndP

;*****************************************************************************
; Makro ustawiajace kwadratowy pixel
;*****************************************************************************
Kwadrat_pix     Macro
        mov     dx, 3cch
        in      al, dx
        or      al, 11000000b
        mov     dx, 3c2h
        out     dx, al
EndM

;*****************************************************************************
; Makro ustawiajace zwykly pixel
;*****************************************************************************
Normal_pix      Macro
        mov     dx, 3cch
        in      al, dx
        and     al, 01111111b
        mov     dx, 3c2h
        out     dx, al
EndM

;*****************************************************************************
; Procka czeka na ramke, zmienia strony i wychodzi z intra po nacisnieciu esc
; Jesli eax = 0 to nie wyswietla smieci.
;*****************************************************************************
esc_key Proc
;        push    eax

        cmp     text_status, 2
        jne     brak_nowego_tekstu

        mov     ebp, text_addy
        mov     edx, [ebp]
        add     ebp, 4

        mov     al, [ebp]
        cmp     al, 0
        je      nie_czysc
        mov     edi, mem_allocated
        add     edi, Font_buf_ofs
        xor     eax, eax
        mov     ecx, 320*200/2
        rep     stosd

nie_czysc:
        inc     ebp
        mov     edi, edx
        call    Write_text
        mov     text_status, 1

brak_nowego_tekstu:
        cmp     text_status, 1
        jl      nie_wyswietlaj
        mov     edi, virtual_screen
        mov     esi, mem_allocated
        add     esi, Font_buf_ofs
        mov     ecx, 320*200
k_pet:
        lodsw
        cmp     ax, 0
        jz      bez_wysw
        mov     [edi], ax
bez_wysw:
        add     edi, 2
        dec     ecx
        jnz     k_pet

nie_wyswietlaj:

;        pop     eax
;        cmp     eax, 0
;        je      bez_smieci
;        call    smieci
;bez_smieci:

        mov     al, whooz_status
        cmp     al, 1
        jne     nie_1
        call    whooz_normal
nie_1:

        mov     ebp, light
        call    AddLight

        mov     ah, Wait_VBL
        Int_EOS

;        xor     edx, edx
;        cmp     wstrzas, 0
;        je      bez_wstrzasu
;        mov     edx, 10
;bez_wstrzasu:
;        xor     ecx, ecx
;        mov     eax, 80h
;        call    VBE_SetDisplayStart

        mov     ecx, VBE_PageSize
        shr     ecx, 2
        VBE_SwapPages

        in      al, 60h
        dec     al
        jz      wyjscie
        ret
esc_key EndP

;*****************************************************************************
; Procka czeka dopoki TimerCount jest rowne prevTimerCount
;*****************************************************************************
wait_timer      Proc
wt_pet:
        mov     eax, prevTimerCount
        cmp     TimerCount, eax
        jz      wt_pet

        ret
wait_timer      EndP

;*****************************************************************************
; Procka robi prevTimerCount = TimerCount
;*****************************************************************************
wyrownaj_timer  Proc
        mov     eax, TimerCount
        mov     prevTimerCount, eax
        ret
wyrownaj_timer  EndP

;*****************************************************************************
; Zwraca liczbe losowa w bx - made by Mrock/Hellcore
;*****************************************************************************
Random  Proc
        mov     bx, Randmval2
        mov     ax, Randmval
        add     bx, 3132h
        add     ax, 0f1adh
        rol     ax, 2
        mov     Randmval, ax
        ror     bx, 1
        add     bx, ax
        mov     Randmval2, bx

        ret
Randmval        dw      0
Randmval2       dw      0
Random  EndP

;*****************************************************************************
; Robi plynne przejscie kolorow
; Wejscie:
;   EDI - bufor ( Ilosc * 3 ) bajtow
; Wyjscie:
;   brak
;*****************************************************************************
delta_r dd 0
delta_g dd 0
delta_b dd 0
Rainbow Macro R1, G1, B1, R2, G2, B2, Ilosc
local petla
        mov     ebx, Ilosc
        mov     eax, R2
        sub     eax, R1
        sal     eax, 16
        cdq
        idiv    ebx
        mov     delta_r, eax

        mov     eax, G2
        sub     eax, G1
        sal     eax, 16
        cdq
        idiv    ebx
        mov     delta_g, eax

        mov     eax, B2
        sub     eax, B1
        sal     eax, 16
        cdq
        idiv    ebx
        mov     delta_b, eax

        mov     eax, R1
        mov     ebx, G1
        mov     ecx, B1
        mov     ebp, Ilosc
petla:
        mov     edx, eax
        shr     edx, 16
        mov     [edi], dl

        mov     edx, ebx
        shr     edx, 16
        mov     [edi + 1], dl

        mov     edx, ecx
        shr     edx, 16
        mov     [edi + 2], dl

        add     eax, delta_r
        add     ebx, delta_g
        add     ecx, delta_b
        add     edi, 3

        dec     ebp
        jnz     petla
EndM

smieci  Proc
        mov     edi, virtual_screen
        xor     edx, edx
sm_pet_zew:
        call    Random
        and     ebx, 0111b
        add     edx, ebx

        mov     eax, ebx
        mov     ecx, ebx
        sal     eax, 9
        sal     ecx, 7
        add     eax, ecx

        add     edi, eax
        mov     esi, o linia
        mov     ecx, 160
        rep     movsd
        inc     edx

        cmp     edx, 200
        jl      sm_pet_zew

        ret
smieci  EndP
